		;calcul du decalage des pointeurs d'une ligne a l'autre
		lw		r7, rows(r0)
		lw		r5, cols(r0)
		subi		r7,r7,#2

		;initialisation
start:		add		r1,r0,ime
		add		r4,r0,ims
		
		;calcul de la borne suprieure de la boucle 
		; cols*(rows-2)-2

		mult		r7,r7,r5
		slli		r6,r5,#2 	; w
		addi		r4,r4,#4
		;pointeurs des lignes infrieures
		add		r2,r1,r6
		add		r3,r1,r6

		add		r4,r4,r6
		subi		r7,r7,#2

		;pointeur initial sur l'image de sortie

		
		
;Optimisation: si on fait 2 boucles de bornes superieures respectives cols-2 et rows-2, on traite alors l'image d'entre moins un cadre d'un pixel tout autour.
;Les points non traits correspondent aux premiere et derniere colonnes, points inutiles a traiter car situs sur les bords (effet de bord).
;On diminue le nombre de calcul de 2*(rows-1).
;Sinon il faudrait dupliquer le contour exterieur de l'image par un autre contour superieur de maniere a ce qu'il y ait un gradient nul pour les bords de l'image et un gradient de 45 dans les coins.
		
		;debut du traitement
boucle:		lw		r15,0(r1)	; i00
		lw		r16,4(r1)	; i01
		lw		r17,8(r1)	; i02
		lw		r18,0(r2)	; i10
		lw		r19,8(r2)	; i12
		lw		r20,0(r3)	; i20
		lw		r21,4(r3)	; i21
		lw		r22,8(r3)	; i22
		
		sub		r23,r20,r15
		sub		r24,r21,r16
		sub		r25,r22,r17
		slli		r24,r24,#1
		add		r26,r25,r23
		add		r26,r24,r24		; H
       	slti		r28,r26,#0		; is value < 0 ?

		sub		r23,r17,r15
		sub		r24,r19,r18
		sub		r25,r22,r20
		slli		r24,r24,#2
		add		r27,r25,r23
		add		r27,r24,r24		; V
       	slti		r29,r27,#0		; is value < 0 ?

      	beqz		r28, absH 		; if r28 is positive, skip next instruction
	nop    	   	
	sub 		r26,r0,r26
absH:		;r26 now contains the absolute value of H

      	beqz		r29, absV  		; if r29 is positive, skip next instruction
	nop
    	   	sub 		r27, r0, r27
absV:		;r27 now contains the absolute value of V


		add		r28,r27,r26		; GN
		;srai		r28,r28,#1		; division par 2
		sgti		r29,r28,#255		; is value > 255 ?

		addi		r1,r1,#4		; changement du pointeur 1 sur ime
		addi		r2,r2,#4		; changement du pointeur 2 sur ime
		addi		r3,r3,#4		; changement du pointeur 3 sur ime

		beqz		r29, overflow
		addi		r28,r0,#255
overflow:	;r28 now contains the corrected gradient

		subi		r7,r7,#1 		; dcrmentation du compteur i

		sw		0(r4),r28		; stockage en memoire du resultat
		addi		r4,r4,#4		; changement du pointeur sur ims
		bnez		r7,boucle		; bouclage
		nop
		trap	#0
		
;
;	A TERMINER : la mthode d'criture dans un fichier
;
;
;	Pour optimisation : factoriser les calculs des gradients
;	H = - i00 - 2*i01 - i02 + i20 + 2*i21 + i22;
;	V = - i00 + i02 - 2*i10 + 2*i12 - i20 + i22;
;
;	C = i22 - i00;
;	S = i20 - i02;
;	H = C + S + 2*(i21 - i01);
;	V = C - S + 2*(i12 - i10);
